// Copyright (c) 2014-present, Facebook, Inc. All rights reserved.
//
// You are hereby granted a non-exclusive, worldwide, royalty-free license to use,
// copy, modify, and distribute this software in source code or binary form for use
// in connection with the web services and APIs provided by Facebook.
//
// As with any software that integrates with the Facebook platform, your use of
// this software is subject to the Facebook Developer Principles and Policies
// [http://developers.facebook.com/policy/]. This copyright notice shall be
// included in all copies or substantial portions of the software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
// FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
// COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
// IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
// CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

#import <Foundation/Foundation.h>

@class FBSDKURL;

NS_ASSUME_NONNULL_BEGIN

extern NSString *const kGamingPayload;
extern NSString *const kGamingPayloadGameRequestID;
extern NSString *const kGamingPayloadContextTokenID;

NS_SWIFT_NAME(GamingPayload)
@interface FBSDKGamingPayload : NSObject

@property (nonatomic, strong, nonnull) FBSDKURL *URL;
@property (nonatomic, strong, readonly) NSString *payload;
@property (nonatomic, strong, readonly) NSString *gameRequestID
DEPRECATED_MSG_ATTRIBUTE("The gameRequestID property will be removed from GamingPayload in the next major release. Use the GamingPayloadDelegate delegate method `parsedGameRequestURLContaining:gameRequestID:` instead.");

- (instancetype)init NS_UNAVAILABLE;
+ (instancetype)new NS_UNAVAILABLE;

- (instancetype)initWithURL:(FBSDKURL * _Nonnull)url
NS_SWIFT_NAME(initWith(URL:));

@end

NS_ASSUME_NONNULL_END
